﻿using System;

namespace HSR.CloudTaskParallelism._Samples.Factorize {
  class Program {
    private const int _NofNumbers = 50;
    private const int _Seed = 4711; // deterministic performance measurements
    

    static void Main(string[] args) {
      _MeasureFactorization("Distributed Tasks", Factorization.DistributedComputeTasks);
      _MeasureFactorization("Distributed For-Loop", Factorization.DistributedComputeForLoop);
      _MeasureFactorization("Local Parallel Tasks", Factorization.ParallelComputeTasks);
      _MeasureFactorization("Local Parallel For-Loop", Factorization.ParallelComputeTasks);
      _MeasureFactorization("Sequential", Factorization.SequentialCompute);
    }


    private static void _MeasureFactorization(string name, Action<long[]> action) {
      // determinstic measurements with exactly the same input number sequence
      long[] inputs = new InputGenerator(_Seed).GetInputSeries(_NofNumbers);
      Console.WriteLine("Start computation");
      DateTime startTime = DateTime.Now;
      action(inputs);
      DateTime stopTime = DateTime.Now;
      Console.WriteLine("{0}: {1} ms", name, (stopTime - startTime).TotalMilliseconds);
    }
  }
}
