﻿
namespace HSR.CloudTaskParallelism._Samples.Mandelbrot {
  public class Complex {
    private double _real;
    private double _img;

    public Complex(double real, double img) {
      _real = real;
      _img = img;
    }

    public double Magnitude {
      get { return _real * _real + _img * _img; }
    }

    public static Complex operator *(Complex a, Complex b) {
      return new Complex(a._real * b._real - a._img * b._img, a._real * b._img + a._img * b._real);
    }

    public static Complex operator +(Complex a, Complex b) {
      return new Complex(a._real + b._real, a._img + b._img);
    }
  }
}
